#lang slideshow

(require "utils/alg.rkt"
         "utils/utils.rkt"
         "utils/colors.rkt")

(define NoteColor "brown")

(define my-line-sep (current-line-sep))

(slide
 (vc-append
  my-line-sep
  (titlet "CS 5510")
  (titlet "Programming Languages"))
 (blank)
 (scale/improve-new-text (t "Fall 2013") 0.75)
 (blank)
 (blank)
 (hbl-append
  (t "Instructor: ")
  (colorize (bt "Matthew Flatt") BlueColor)))

(slide
 #:title "Course Details"
 (tt "http://www.eng.utah.edu/~cs5510/"))

(define blank-bullet (ghost bullet))

(slide
 #:title "Programming Language Concepts"
 (blank)
 (para "This course teaches concepts in two ways:")
 'next
 (blank)
 (colorize
  (item #:bullet blank-bullet "By implementing" (bt "interpreters"))
  NoteColor)
 (subitem "new concept" sym:implies "new interpreter")
 'next
 (blank)
 (colorize
  (item #:bullet blank-bullet "By using" (bt "Racket") "and variants")
  NoteColor)
 (subitem "we don't assume that you already know Racket"))

;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (aside . l)
  (scale/improve-new-text
   (apply para #:align 'center #:width (* 0.9 client-w) l)
   0.9))

(slide
 #:title "Interpreters"
 (blank)
 (para "An" (dt "interpreter") "takes a program and produces a result")
 (vl-append
  my-line-sep
  (subitem "DrRacket")
  (subitem "x86 processor")
  (subitem "desktop calculator")
  (subitem (tt "bash"))
  (subitem "Algebra student"))
 'next
 (blank)
 (para "A" (dt "compiler") "takes a program and produces another program")
 (blank)
 (blank)
 (aside "In the terminology of programming languages, someone who translates"
        "Chinese to English is a" (it "compiler") ", not an" (it "interpreter")"."))

;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (begat-arrow a) (inset (arrow (/ (current-font-size) 2) a) (/ gap-size 2) 0))

(define begat (begat-arrow 0))
(define tageb (begat-arrow (- pi)))
(define (ebt s) (colorize (if (pict? s) s (bt s)) NoteColor))

(slide
 #:title (hbl-append (titlet "Racket and ") (tt "plai-typed"))
 (para (ebt "Lisp") begat (ebt "Scheme") begat (ebt "Racket"))
 'next
 (blank)
 (para (bt "Racket") "is")
 (item "a programming language")
 (item "a family of programming languages")
 (item "a language for creating programming languages")
 'next
 (para #:align 'right "... including" (ebt (tt "plai-typed")))
 'next
 (blank)
 (para #:align 'center
       (ebt "Racket") begat (inset (ebt (tt "plai-typed")) (/ gap-size 2) 0) tageb (ebt "ML"))
 (blank)
 (blank)
 (parameterize ([current-font-size (floor (* #e0.7 (current-font-size)))])
   (para #:align 'right
         "PLAI =" (it "Programming Languages: Application and Interpretation") ", the textbook")))

(slide
 #:title (tt "plai-typed")
 (para #:fill? #f "See" (tt "quick-ref.rkt")))

;; ----------------------------------------

(slide
 #:title "Homework 0"
 (item "Create handin account")
 (item (hbl-append (t "Racket/") (tt "plai-typed") (t " warm-up exercises")))
 (blank)
 (colorize
  (para #:align 'center "Due Friday,\xA0August 30")
  NoteColor))
